apiVersion: apps/v1
kind: Deployment
metadata:
  name: {{ .Values.app.name }}
  labels:
    app: {{ .Values.app.name }}
spec:
  selector:
    matchLabels:
      app: {{ .Values.app.name }}
  template:
    metadata:
      labels:
        app: {{ .Values.app.name }}
    spec:
      containers:
        - image: "{{ .Values.image.name }}:{{ .Values.image.tag }}"
          name: "{{ .Values.app.name }}"
          ports:
            - name: "{{ .Values.app.name }}"
              containerPort: {{ .Values.app.port }}
          volumeMounts:
            - name: initdb
              mountPath: /docker-entrypoint-initdb.d
          env:
            - name: MONGODB_DATABASE
              valueFrom:
                configMapKeyRef:
                  name: {{ .Values.app.name }}
                  key: database.name
            - name: MONGODB_USERNAME
              valueFrom:
                secretKeyRef:
                  name: {{ .Values.app.name }}
                  key: database-user
            - name: MONGODB_PASSWORD
              valueFrom:
                secretKeyRef:
                  name: {{ .Values.app.name }}
                  key: database-password
            - name: MONGODB_ROOT_PASSWORD
              valueFrom:
                secretKeyRef:
                  name: {{ .Values.app.name }}
                  key: root-password
      volumes:
        - name: initdb
          configMap:
            name: initdb
